#include <windows.h>
#include <cstdio>

using namespace std;

void TrazarTexto(int x, int y, char *texto) {
    HANDLE hMutex;
    COORD dwPos = {x, y};

    hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, "MutexAccesoPantalla");

    if(WaitForSingleObject(hMutex, INFINITE) == WAIT_OBJECT_0){
        SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
        printf("%s", texto);
        ReleaseMutex(hMutex);
    }
    CloseHandle(hMutex);
}

struct stHora {
    int x;
    int y;
    bool salir;
};

DWORD WINAPI MostrarHora( void* par) {
    stHora *hora = (stHora*)par;      // Recuperar el parmetro, un puntero a stHora
    SYSTEMTIME st;                    // Estructura para obtener la hora
    int seg = 0;                      // Variable auxiliar para detectar cambio de segundo
    char texto[9];                    // Variable con el texto de la hora

    do {
        // Esperamos a que cambie el segundo:
        while(seg == st.wSecond) {
            GetLocalTime(&st);
            Sleep(100);
        }
        // Mostrar la hora:
        sprintf(texto, "%02d:%02d:%02d", st.wHour, st.wMinute, st.wSecond);
        TrazarTexto(hora->x, hora->y, texto);
        // Almacenar el segundo actual:
        seg = st.wSecond;
    } while(!hora->salir); // Repetir hasta que salir sea true

    printf("\nAbandonando el hilo\n");
    return 0;
}

int main() {
    HANDLE hHilo[4];
    stHora hora={70, 1, false};
    stHora hora2={1, 1, false};
    stHora hora3={70, 23, false};
    stHora hora4={1, 23, false};

    HANDLE hMutex = CreateMutex(NULL, FALSE, "MutexAccesoPantalla");

    // Crear los hilos
    hHilo[0] = CreateThread( 0, 0, MostrarHora, (void*)&hora, 0, 0);
    hHilo[1] = CreateThread( 0, 0, MostrarHora, (void*)&hora2, 0, 0);
    hHilo[2] = CreateThread( 0, 0, MostrarHora, (void*)&hora3, 0, 0);
    hHilo[3] = CreateThread( 0, 0, MostrarHora, (void*)&hora4, 0, 0);

    // Esperar a que el usuario pulse una tecla, el hilo se sigue ejecutando:
    TrazarTexto(4,10,"Pulsa una tecla para salir");
    getchar();
    hora.salir = true;
    hora2.salir = true;
    hora3.salir = true;
    //hora4.salir = true;

    // Esperar a que terminen los hilos:
    WaitForMultipleObjects(4, hHilo, TRUE, 2000);

	// Liberar manipuladores:
    CloseHandle(hHilo[0]);
    CloseHandle(hHilo[1]);
    CloseHandle(hHilo[2]);
    CloseHandle(hHilo[3]);
    CloseHandle(hMutex);
    return 0;
}
